#include "mainFrame.h"

using namespace std;

void leggiFile();
void aggiungi( string arg );
int cerca( string arg );
void elimina( int n_linea );
int len();
void getMarked(int line_num, int value);

wxSplitterWindow *splitter;
wxGrid *grid;
wxTextCtrl *testo;

int x_cell_pos = -1;
int Y_cell_pos = -1;

int elemento_da_markare = - 1;
string PATH = "file/file.csv";

#include "log_lib.hpp"

MainFrame::MainFrame(const wxString& title)
       : wxFrame(NULL, wxID_ANY, title, wxDefaultPosition, wxSize(1000, 750) /*wxSize(450, 300)*//* -->Display 10pp*/)
{

  this -> SetMinSize(wxSize(1000,750)); //dimensione minima della finestra

  //========DECOMMENTARE LINEA IN CASO DI DISPLAY A 10''========//
  //this -> SetMinSize(wxSize(450, 300));

  //======== DECOMMENTARE LINEA IN CASO SCHERMO INTERO ========//
  //this->ShowFullScreen(true);

  splitter = new wxSplitterWindow(this, wxID_ANY, wxDefaultPosition, wxDefaultSize, wxSP_BORDER | wxSP_LIVE_UPDATE);
  splitter -> SetMinimumPaneSize(10);

  this -> SetIcon(wxIcon("img/icon.png"));

  wxPanel *left = new wxPanel(splitter);

  grid = new wxGrid(splitter, wxID_ANY);
  grid -> CreateGrid(1,1);

  grid -> SetLabelBackgroundColour(wxColor(66,150,90));
  grid -> SetColSize(0, 750);
	  //grid -> HideRowLabels();
  grid -> SetRowLabelSize(25);

  grid -> SetColLabelValue(0, "TASK");

  grid->Bind(wxEVT_GRID_CELL_LEFT_CLICK, &MainFrame::OnGridCellLeftClick, this);



  leggiFile();

  splitter -> SplitVertically(left, grid);

  testo = new wxTextCtrl(left, wxID_ANY, wxEmptyString, wxPoint(20, 10), wxSize(185, 30), wxTE_PROCESS_ENTER);
  testo->Connect(wxEVT_TEXT_ENTER, wxCommandEventHandler(MainFrame::OnEnterPressed), NULL, this);






  //bottone aggiungi
  wxButton *bottone_aggiungi = new wxButton(left, BUTTON_add, wxT("+"),
	  wxPoint(20, 45));
  bottone_aggiungi->SetBackgroundColour(wxColor(68, 166, 76));
  Connect(BUTTON_add, wxEVT_COMMAND_BUTTON_CLICKED,
	  wxCommandEventHandler(MainFrame::Add));
  bottone_aggiungi->SetFocus();

  //bottone rimuovi
  wxButton *bottone_elimina = new wxButton(left, BUTTON_del, wxT("-"),
	  wxPoint(120, 45));
  bottone_elimina->SetBackgroundColour(wxColor(68, 166, 76));
  Connect(BUTTON_del, wxEVT_COMMAND_BUTTON_CLICKED,
	  wxCommandEventHandler(MainFrame::Del));
  bottone_elimina->SetFocus();

  //bottone evidenzia
  wxButton *marker = new wxButton(left, BUTTON_mark, wxT("MARK"),
	  wxPoint(20, 85));
  marker->SetBackgroundColour(wxColor(68, 166, 76));
  Connect(BUTTON_mark, wxEVT_COMMAND_BUTTON_CLICKED,
	  wxCommandEventHandler(MainFrame::Mark));
  marker->SetSize(185, 30);
  marker->SetFocus();

  //bottone rimuovi evidenziamento
  wxButton *unmarker = new wxButton(left, BUTTON_unmark, wxT("UNMARK"),
	  wxPoint(20, 120));
  unmarker->SetBackgroundColour(wxColor(68, 166, 76));
  Connect(BUTTON_unmark, wxEVT_COMMAND_BUTTON_CLICKED,
	  wxCommandEventHandler(MainFrame::UnMark));
  unmarker->SetSize(185, 30);
  unmarker->SetFocus();



  Centre();

}

//classe per selezionare la cella con il click sinistro del mouse
void MainFrame::OnGridCellLeftClick(wxGridEvent& event)
{
        int row = event.GetRow();
        int col = event.GetCol();

        x_cell_pos = row;
        Y_cell_pos = col;

        //wxLogMessage("Cella cliccata: (%d, %d)", x_cell_pos, Y_cell_pos);
        event.Skip();  // Permette agli altri gestori di eventi di eseguire le loro azioni
}


//classe per aggiungere un task dopo avere premuto invio
void MainFrame::OnEnterPressed(wxCommandEvent& event) {
	string testo_della_box = testo->GetValue().ToStdString();
		if (testo_della_box != "")
		{
			aggiungi( testo_della_box );
			leggiFile();
			testo -> SetValue("");
		}
		else
		{
			wxMessageDialog *dial = new wxMessageDialog(NULL,
				wxT("EMPTY FIELD"), wxT("WARNING"), wxOK);
			dial -> ShowModal();
		}
		log_write(1);
}

//classe per aggiornare la tabella
void MainFrame::UpdateGrid()
{
    // Aggiorna la visualizzazione della griglia
    grid->ForceRefresh();
    grid->Update();
}

//=-=-=-=-=-=-=-CLASSE PER AGGIUNGERE UN COMPITO=-=-=-=-=-=-=-//
void MainFrame::Add(wxCommandEvent & event)
{
	string testo_della_box = testo->GetValue().ToStdString();
	if (testo_della_box != "")
	{
		aggiungi( testo_della_box );
		leggiFile();
		testo -> SetValue("");
	}
	else
	{
		wxMessageDialog *dial = new wxMessageDialog(NULL,
			wxT("EMPTY FIELD"), wxT("WARNING"), wxOK);
		dial -> ShowModal();
	}
	log_write(1);
}

//=-=-=-=-=-=-=-CLASSE PER RIMUOVERE UN COMPITO=-=-=-=-=-=-=-//
void MainFrame::Del(wxCommandEvent & event)
{

	if ( x_cell_pos == -1 )
	{
		wxMessageDialog *dial = new wxMessageDialog(NULL,
			wxT("NO SELECTED CELL"), wxT("ERROR"), wxICON_ERROR);
		dial -> ShowModal();

	}

	if (x_cell_pos  > -1) {

		string testo_della_cella = grid->GetCellValue(x_cell_pos, 0).ToStdString();

		elimina( cerca( testo_della_cella ) );
		leggiFile();
		testo -> SetValue("");

		x_cell_pos = -1;
		log_write(2);
	}

	UpdateGrid();
}

//=-=-=-=-=-=-=-CLASSE PER EVIDENZIARE UN COMPITO=-=-=-=-=-=-=-//
void MainFrame::Mark(wxCommandEvent & event)
{
	//controllo se sono selezionate più celle
	wxGridCellCoordsArray get_cell_selected = grid->GetSelectedCells();
	string testo_della_cella = "";
	if (get_cell_selected.GetCount() != 0) {
		testo_della_cella = grid->GetCellValue(grid->GetSelectedCells()[0]).ToStdString();
	}

	int num = -1;
	for (int i=0; i<len(); i++)
	{
		if(grid -> GetCellValue(i, 0).ToStdString() == testo -> GetValue().ToStdString() || grid -> GetCellValue(i, 0).ToStdString() == testo_della_cella)
		{
			num = i;
			elemento_da_markare = num;
			getMarked(num+1, 1);
			break;
		}
	}

	if ( x_cell_pos == -1 )
	{
		wxMessageDialog *dial = new wxMessageDialog(NULL,
			wxT("NO MATCHING WORD OR NOT SELECTED CELL"), wxT("ERROR"), wxICON_ERROR);
		dial -> ShowModal();

	}

	if (x_cell_pos  > -1) {
		grid -> SetCellBackgroundColour(x_cell_pos, 0, wxColor(70, 189, 92));
		grid -> SetCellTextColour(x_cell_pos, 0, wxColor(0, 0, 0));
		testo -> SetValue("");
		getMarked(x_cell_pos+1, 1);
		x_cell_pos = -1;
		log_write(3);
	}

	UpdateGrid();

}

//=-=-=-=-=-=-=-CLASSE PER RIMUOVERE EVIDENZIAZIONE DA UN COMPITO=-=-=-=-=-=-=-//
void MainFrame::UnMark(wxCommandEvent & event)
{
	//controllo se sono selezionate più celle
	wxGridCellCoordsArray get_cell_selected = grid->GetSelectedCells();
	string testo_della_cella = "";
	if (get_cell_selected.GetCount() != 0) {
		testo_della_cella = grid->GetCellValue(grid->GetSelectedCells()[0]).ToStdString();
	}

	int num = -1;
	for (int i=0; i<len(); i++)
	{
		if(grid -> GetCellValue(i, 0).ToStdString() == testo -> GetValue().ToStdString() || grid -> GetCellValue(i, 0).ToStdString() == testo_della_cella)
		{
			num = i;
			elemento_da_markare = num;
			getMarked(num+1, 0);
			break;
		}
	}

	if ( x_cell_pos == -1 )
	{
		wxMessageDialog *dial = new wxMessageDialog(NULL,
			wxT("NO MATCHING WORD OR NOT SELECTED CELL"), wxT("ERROR"), wxICON_ERROR);
		dial -> ShowModal();

	}

	if (x_cell_pos % 2 == 0)
	{
		grid -> SetCellBackgroundColour(x_cell_pos, 0, wxColor(69, 69, 69));
		grid -> SetCellTextColour(x_cell_pos, 0, wxColor(217, 217, 217));

		getMarked(x_cell_pos+1, 0);
		x_cell_pos = 1;

		log_write(4);
	}
	else if (x_cell_pos % 2 != 0)
	{
		grid -> SetCellBackgroundColour(x_cell_pos, 0, wxColor(97, 97, 97));
		grid -> SetCellTextColour(x_cell_pos, 0, wxColor(217, 217, 217));

		getMarked(x_cell_pos+1, 0);
		x_cell_pos = -1;

		log_write(4);
	}

	elemento_da_markare = -1;
	testo -> SetValue("");

	UpdateGrid();

}

//===RESTITUISCE LE LINEE MARCATE ;1 NEL FILE===//
void getMarked(int line_num, int value) {
	ifstream inputFile;
	inputFile.open(PATH);


	ofstream outputFile;
	outputFile.open("file/output_file.txt");

	string linea;

	string parola;
	vector <string> word;

	int n = 1;

	if ( outputFile.is_open() ) {

		while(getline(inputFile, linea))
		{

			if (n != line_num)
			{
				outputFile << linea << endl;
			}

			else
			{
				stringstream str(linea);

				while (getline(str, parola, ';'))

				{
					word.push_back(parola);
				}

				if (value == 1)
				{
					outputFile << word[0] << ";1" << endl;
				}

				else
				{
					outputFile << word[0] << ";0" << endl;
				}
			}

			word.clear();
			n ++;
		}
	}

	else
	{
		wxMessageDialog *dial = new wxMessageDialog(NULL,
			wxT("CAN NOT OPEN FILE"), wxT("ERROR"), wxICON_ERROR);
		dial -> ShowModal();
	}

	inputFile.close();
	outputFile.close();

	remove("file/file.csv");
	rename("file/output_file.txt", "file/file.csv");
}

//===LEGGE IL FILE E AGGIUNGE ALLA TABELLA LE RIGHE===//
void leggiFile() {
	if (grid -> GetNumberRows() > 1) {
		grid -> DeleteRows(0, grid->GetNumberRows()-1, true);
	}
	fstream file;
	file.open(PATH, ios::in); //input filestream
	string linea = "";
	string parola;

	vector <string> word;

	int conta_elementi = 1;

	if ( file.is_open() ) {
		while(getline(file, linea)) {

			//parsing
			stringstream str(linea);

			while (getline(str, parola, ';')) {
				word.push_back(parola);
			}

			//Controllo se il file è vuoto
			if (len() == 1)
			{
				grid -> AppendRows(1);
				grid -> SetCellValue(0, 0, word[0]);
				grid -> AppendRows(1);
				grid -> ForceRefresh();
			}
			else
			{
				grid -> SetCellValue(conta_elementi -1, 0, word[0]);
				grid -> AppendRows(1);
				grid -> ForceRefresh();
			}

		  	conta_elementi ++;
		  	if (conta_elementi%2 == 0)
		  	{
		  		grid -> SetCellBackgroundColour(conta_elementi-2, 0, wxColor(69, 69, 69));
		  		grid -> SetCellTextColour(conta_elementi-2, 0, wxColor(217, 217, 217));
		  	}
		  	else
		  	{
		  		grid -> SetCellBackgroundColour(conta_elementi-2, 0, wxColor(97, 97, 97));
		  		grid -> SetCellTextColour(conta_elementi-2, 0, wxColor(217, 217, 217));
		  	}

		  	if (word[1] == "1")
		  	{
		  		grid -> SetCellBackgroundColour(conta_elementi-2, 0, wxColor(70, 189, 92));
		  		grid -> SetCellTextColour(conta_elementi-2, 0, wxColor(0, 0, 0));
		  	}

		  	word.clear();
		}
	} else {
		wxMessageDialog *dial = new wxMessageDialog(NULL,
			wxT("CAN NOT OPEN FILE"), wxT("ERROR"), wxICON_ERROR);
		dial -> ShowModal();
	}

	grid->EnableEditing(false);

	grid -> DeleteRows(conta_elementi-1,1);
	grid -> ForceRefresh();
	//transfertToCSV();
}

//===AGGIUNGE UNA LINEA NEL FILE===//
void aggiungi( string arg ) {

	ofstream file;

	file.open(PATH, ios::app);

	if ( file.is_open() ) {
		file << arg;
		file << ";0\n";
	} else {
		wxMessageDialog *dial = new wxMessageDialog(NULL,
			wxT("CAN NOT OPEN FILE"), wxT("ERROR"), wxICON_ERROR);
		dial -> ShowModal();
	}

	file.close();

}

//===TROVA UNA RIGA NEL FILE===//
int cerca( string arg ) {

	ifstream file;
	file.open(PATH, ios::in);

	int num_linea = 1;

	string linea = "";

	string arg1, arg2;

	arg1 = arg+";1";
	arg2 = arg+";0";


	if ( file.is_open() ) {
		while ( file.good() ) {
			getline(file, linea);
			if ( linea != arg2 && linea != arg1) {
				num_linea ++;
			} else {
				file.close();
				return num_linea;
			}
		}
	} else {
		wxMessageDialog *dial = new wxMessageDialog(NULL,
			wxT("CAN NOT OPEN FILE"), wxT("ERROR"), wxICON_ERROR);
		dial -> ShowModal();
	}

	file.close();
	return -1;

}

//===ELIMINA UNA RIGA NEL FILE===//
void elimina( int n_linea ) {

	ifstream inputFile;
	inputFile.open(PATH);


	ofstream outputFile;
	outputFile.open("file/output_file.txt");

	string linea;

	int n = 1;

	if ( outputFile.is_open() ) {
		while(getline(inputFile, linea)) {
			if (n != n_linea) {
				outputFile << linea << endl;
			}
			n ++;
		}
	} else {
		wxMessageDialog *dial = new wxMessageDialog(NULL,
			wxT("CAN NOT OPEN FILE"), wxT("ERROR"), wxICON_ERROR);
		dial -> ShowModal();
	}

	inputFile.close();
	outputFile.close();

	remove("file/file.csv");
	rename("file/output_file.txt", "file/file.csv");

}


//===RESTITUISCE LA LUNGHEZZA DEL FILE===//
int len() {

	int len = 0;

	string line = "";

	ifstream file;
	file.open(PATH, ios::in);

	if ( file.is_open() ) {
		while ( file.good() ) {
			getline(file, line);
			len ++;
		}
	} else {
		wxMessageDialog *dial = new wxMessageDialog(NULL,
			wxT("CAN NOT OPEN FILE"), wxT("ERROR"), wxICON_ERROR);
		dial -> ShowModal();
	}

	file.close();

	return len - 1;
}
